<template>
  <div>
    <vue-cal
      locale="fr"
      :disable-views="['years', 'year', 'week', 'day']"
      :events="events"
      default-view="month"
      hide-view-selector
      hide-title-bar
      events-on-month-view
      :dbl-click-to-navigate="false"
      :cell-click-hold="false"
      :selected-date="currentMonthDate"
      @cell-click="selectCell"
    >
      <template #weekday-heading="{ heading: { label } }">
        <span class="is-size-8 has-text-weight-bold is-uppercase">{{ label.substr(0, 3) }}.</span>
      </template>
      <template #cell-content="{ cell, events }">
        <mt-cell-content
          :disponibilites="effectifs[cell.formattedDate]"
          :disponibilite-employe="disponibilitesEmploye[cell.formattedDate]"
          :cell="cell"
          :events="events"
          :selected-date-end="selectedDateEnd"
          :selected-date-start="selectedDateStart"
          :disable-create="disableCreate"
          :disponibilites-complete-entre="disponibilitesCompleteEntre"
          @disponibilite-choisie="disponibiliteChoisie"
          @close="close"
        />
      </template>
      <template #event="{ event }">
        <mt-event
          :position-activites-par-jour="positionsActivitesParJour"
          :event="event"
          :is-my-activities="isMyActivities"
          :selected-groupes="selectedGroupes"
          :interval="currentMonthInterval"
          @affiche-pop-up="affichePopUp"
          @cacher-pop-up="cacherActivite"
        />
      </template>
    </vue-cal>
    <mt-pop-up-activite
      v-if="activite"
      :activite="activite"
      :activite-parent="activiteParent"
      :activites-enfants="activitesEnfants"
      :style-css="stylePopup"
      :afficher="afficher"
    />
  </div>
</template>

<script>
import VueCal from 'vue-cal';
import 'vue-cal/dist/i18n/fr';
import 'vue-cal/dist/vuecal.css';
import { DateTime, Interval } from 'luxon';
import MtEvent from './event';
import MtCellContent from './cell-content';
import userMixin from '~/components/mixins/userMixin';
import MtPopUpActivite from '~/components/activity/popup-activite';

export default {
  components: {
    VueCal,
    MtEvent,
    MtCellContent,
    MtPopUpActivite,
  },
  mixins: [userMixin],
  props: {
    activites: {
      type: Array,
      default: () => [],
    },
    disponibilites: {
      type: Array,
      default: () => [],
    },
    currentMonthDate: {
      type: Date,
      default: () => new Date(),
    },
    disableCreate: {
      type: Boolean,
      default: false,
    },
    initSelectedDateStart: {
      type: Date,
      default: null,
    },
    initSelectedDateEnd: {
      type: Date,
      default: null,
    },
    selectedGroupes: {
      type: Array,
      default: () => [],
    },
    isMyActivities: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      selectedDateStart: this.initSelectedDateStart,
      selectedDateEnd: this.initSelectedDateEnd,
      disponibilitesCompleteEntre: null,
      stylePopup: {
        left: 'unset',
        top: 'unset',
        bottom: 'unset',
      },
      afficher: false,
      activite: null,
      activitesEnfants: null,
      activiteParent: null,
    };
  },
  computed: {
    events() {
      return this.activites.map((activite) => {
        return {
          startDate: activite.dateDebut,
          endDate: activite.dateFin,
          title: activite.nom,
          activite,
        };
      });
    },
    currentMonthInterval() {
      return Interval.fromDateTimes(
        DateTime.fromJSDate(this.currentMonthDate)
          .startOf('month')
          .startOf('week'),
        DateTime.fromJSDate(this.currentMonthDate)
          .startOf('month')
          .plus({ weeks: 5 })
          .endOf('week'),
      );
    },
    effectifs() {
      const effectifs = {};
      if (this.isEmploye) {
        return effectifs;
      }
      this.disponibilites.forEach((disponibilite) => {
        effectifs[DateTime.fromISO(disponibilite.dateDebut).toISODate()] = disponibilite.effectifs;
      });
      return effectifs;
    },
    disponibilitesEmploye() {
      const disponibilitesEmploye = {};
      if (!disponibilitesEmploye) {
        return disponibilitesEmploye;
      }
      this.disponibilites.forEach((disponibilite) => {
        disponibilitesEmploye[DateTime.fromISO(disponibilite.dateDebut).toISODate()] = disponibilite;
      });
      return disponibilitesEmploye;
    },
    positionsActivitesParJour() {
      const daysEventsPosition = {};
      for (let i = 0; i < this.currentMonthInterval.count('days'); i += 1) {
        const day = this.currentMonthInterval.start.plus({ days: i });
        daysEventsPosition[day.toISODate()] = this.eventsPositionByDay(
          day,
          i === 0 ? null : daysEventsPosition[day.minus({ days: 1 }).toISODate()],
        );
      }
      return daysEventsPosition;
    },
  },
  watch: {
    initSelectedDateStart(val) {
      this.selectedDateStart = val;
    },
    initSelectedDateEnd(val) {
      this.selectedDateEnd = val;
    },
  },
  methods: {
    affichePopUp({ activite, afficher, stylePopup, activiteParent, activitesEnfants }) {
      this.afficher = afficher;
      this.stylePopup = stylePopup;
      this.activite = activite;
      this.activiteParent = activiteParent;
      this.activitesEnfants = activitesEnfants;
    },
    cacherActivite() {
      this.afficher = false;
    },
    onViewChange(monthDateTime) {
      this.$emit('view-change', {
        firstCellDate: monthDateTime
          .startOf('month')
          .startOf('week')
          .toJSDate(),
        lastCellDate: monthDateTime
          .startOf('month')
          .plus({ weeks: 5 })
          .endOf('week')
          .toJSDate(),
        startDate: monthDateTime.toJSDate(),
      });
    },
    eventsPositionByDay(day, previousDay) {
      const dayInterval = Interval.fromDateTimes(day.startOf('day'), day.endOf('day'));
      const dayEvents = this.activites
        .filter((event) => {
          const eventInterval = Interval.fromDateTimes(
            DateTime.fromJSDate(event.dateDebut),
            DateTime.fromJSDate(event.dateFin),
          );
          return eventInterval.overlaps(dayInterval);
        })
        .sort((evt1, evt2) => evt1.start - evt2.start);
      const eventsPos = {};
      const daysFilled = new Array(dayEvents.length);
      dayEvents.forEach((e, index) => {
        if (previousDay === null) {
          eventsPos[e.id] = index;
        } else if (typeof previousDay[e.id] !== 'undefined' && day.weekday !== 1) {
          eventsPos[e.id] = previousDay[e.id];
          daysFilled[previousDay[e.id]] = 'filled';
        } else {
          const freePosition = daysFilled.findIndex((evt) => evt !== 'filled');
          eventsPos[e.id] = freePosition === -1 ? dayEvents.length - 1 : freePosition;
          eventsPos[e.id] = freePosition;
          daysFilled[freePosition] = 'filled';
        }
      });
      return eventsPos;
    },
    selectCell(date) {
      if (date && date instanceof Date) {
        if (!this.selectedDateStart) {
          this.selectedDateStart = date;
        } else if (!this.selectedDateEnd) {
          if (date.getTime() < this.selectedDateStart.getTime()) {
            this.selectedDateEnd = this.selectedDateStart;
            this.selectedDateStart = date;
          } else {
            this.selectedDateEnd = date;
          }
        } else {
          this.resetSelectedDate();
        }
        this.calculerXYZ();
        this.$emit('date-selected', {
          selectedDateStart: this.selectedDateStart,
          selectedDateEnd: this.selectedDateEnd,
        });
      }
    },
    resetSelectedDate() {
      this.selectedDateStart = null;
      this.selectedDateEnd = null;
    },
    disponibiliteChoisie(id, commentaire) {
      this.selectedDateStart.setHours(8);
      this.selectedDateEnd.setHours(18);

      this.$emit('disponibilite-choisie', {
        dateDebut: this.selectedDateStart.toISOString(),
        dateFin: this.selectedDateEnd.toISOString(),
        typeDisponibilite: {
          id,
        },
        commentaire,
      });
      this.resetSelectedDate();
    },
    async calculerXYZ() {
      if (this.selectedDateEnd && !this.isEmploye) {
        const start = new Date(this.selectedDateStart);
        start.setHours(8);
        const end = new Date(this.selectedDateEnd);
        end.setHours(18);
        this.disponibilitesCompleteEntre = await this.$api
          .organisme()
          .disponibilitesComplete(start.toISOString(), end.toISOString());
      }
    },
    close() {
      this.selectedDateStart = this.initSelectedDateStart;
      this.selectedDateEnd = this.initSelectedDateEnd;
      this.disponibilitesCompleteEntre = null;
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
@import '~/assets/css/calendar.scss';
/deep/ .vuecal__cell--selected {
  z-index: unset !important;
}
</style>
